//+------------------------------------------------------------------+
//|                                           MA Cross and Money.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
//---- input parameters
extern int       maSlow=18;
extern int       maFast=5;
extern bool      ShowLines=true;
//---- buffers
double UpBuffer[];
double DownBuffer[];
double UpStocBuffer[];
double DownStocBuffer[];

double AvgVol = 61;
string Curr = "";
int TimeFrame = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,UpBuffer);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,DownBuffer);
   SetIndexEmptyValue(1,0.0);

   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,217);
   SetIndexBuffer(2,UpStocBuffer);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,218);
   SetIndexBuffer(3,DownStocBuffer);
   SetIndexEmptyValue(3,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   static bool bFirst = true;
   
    int iBar,nCountedBars;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   int limit=Bars-counted_bars;
   
      
   
   Curr = Symbol();
   TimeFrame = Period(); //PERIOD_M15;
   
   if (bFirst)
   {
      bFirst = false;
      CalcAvgVol();
   }
   
   AvgVol = 61;
   
   for(iBar = 0; iBar <= limit; iBar++)
   {
   
      int counter=iBar;
      double Range=0;
      double AvgRange=0;
      
      for (counter=iBar ;counter<=iBar+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;

      DisplayIndicators();
      
      UpBuffer[iBar+1] = 0; DownBuffer[iBar+1] = 0;
      UpStocBuffer[iBar] = 0; DownStocBuffer[iBar] = 0;
      int iCross = maCrossed(iBar+1);
      int iStoc = StochasticCrossed(iBar);
      if (iCross != 0)
      {
            if (iCross == 1)
            {
               if (NewBar() && (iBar < 3))
               {
                  Print("** Xross up");
                  PlaySound("alert.wav");
               }
               UpBuffer[iBar+1] = iLow(Curr, Period(), iBar+1) - 0.5 * Range;
            }
            else
            {
               if (NewBar() && (iBar < 3))
               {
                  Print("** Xross down");
                  PlaySound("alert.wav");
               }
               DownBuffer[iBar+1] = iHigh(Curr, Period(), iBar+1) + 0.5 * Range;
            }
      }
      if (iStoc != 0)
      {
            if (iStoc == 1)
            {
               UpStocBuffer[iBar] = iLow(Curr, Period(), iBar) - 0.5 * Range;
            }
            else
            {
               DownStocBuffer[iBar] = iHigh(Curr, Period(), iBar+1) + 0.5 * Range;
            }
            
      }
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

bool NewBar()
{
   int p = TimeFrame;
   static datetime dtCurrTime = 0;
   
   if (iTime(Curr, p, 0) != dtCurrTime)
   {
      dtCurrTime = iTime(Curr, p , 0);
      return(true);
   }
   return(false);
}


// Calculate the volume average
void CalcAvgVol()
{
   double sum = 0.0;
   for(int ii=1; ii<201; ii++)
   {
      sum += iVolume(Curr, TimeFrame, ii);
   }
   AvgVol = sum / 200;
  
  
  AvgVol = 61;
}


int maCrossed(int i)
{
      double maFastnow = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i);
      double maFastprevious = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double maFastafter = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i-1);

      double maSlownow = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i);
      double maSlowprevious = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double maSlowafter = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i-1);
      
      if ((maFastnow > maSlownow) && (maFastprevious < maSlowprevious)) {// && (maFastafter > maSlowafter)) {
         return(1);
      }
      else if ((maFastnow < maSlownow) && (maFastprevious > maSlowprevious)) { // && (maFastafter < maSlowafter)) {
         return(-1);
      }
 
      return(0);
}

int StochasticCrossed (int i)
{
      double stcFastnow = iStochastic(NULL, 0, 15,5,5, MODE_EMA, 0, MODE_MAIN, i);
      double stcFastprevious = iStochastic(NULL, 0, 15,5,5, MODE_EMA, 0, MODE_MAIN, i+1);
      double stcFastafter = iStochastic(NULL, 0, 15,5,5, MODE_EMA, 0, MODE_MAIN, i-1);

      double stcSlownow = iStochastic(NULL, 0, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, i);
      double stcSlowprevious = iStochastic(NULL, 0, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, i+1);
      double stcSlowafter = iStochastic(NULL, 0, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, i-1);
      
      if ((stcFastnow >stcSlownow) && (stcFastprevious <stcSlowprevious)) {// && (stcFastafter >stcSlowafter)) {
         return(1);
      }
      else if ((stcFastnow <stcSlownow) && (stcFastprevious >stcSlowprevious)) { // && (stcFastafter < stcSlowafter)) {
         return(-1);
      }
 
      return(0);
}

void DisplayIndicators()
{
   double rsi_h1 = iRSI(NULL, PERIOD_H1, 8, PRICE_CLOSE, 0);
   double rsi_m15 = iRSI(NULL, PERIOD_M15, 8, PRICE_CLOSE, 0);
   
   double stoc_H1 = iStochastic(NULL, PERIOD_H1, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, 0);
   double stoc_M15 = iStochastic(NULL, PERIOD_M15, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, 0);
   
   string rsi_rec_h1 = "", rsi_rec_m15 = "";
   
   if ((rsi_h1 > 50) && (stoc_H1 > 40)) { rsi_rec_h1 = "Buy"; }
   if ((rsi_m15 > 50) && (stoc_M15 > 40)) { rsi_rec_m15 = "Buy"; }
   
   if ((rsi_h1 < 50) && (stoc_H1 < 60)) { rsi_rec_h1 = "Sell"; }
   if ((rsi_m15 < 50) && (stoc_M15 < 60)) { rsi_rec_m15 = "Sell"; }

   string sComment = "H1   RSI(<>50): " + DoubleToStr(rsi_h1,0) + " Stoc(>40 <60): " + DoubleToStr(stoc_H1,0) + " " + rsi_rec_h1 + "\n"
                    +"M15  RSI(<>50): " + DoubleToStr(rsi_m15,0)+ " Stoc(>40 <60): " + DoubleToStr(stoc_M15,0)+ " " + rsi_rec_m15 ;
                    
   Comment(sComment);
   
}